unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Placemnt, RXSlider, ComCtrls, StdCtrls, Mask, ToolEdit, Gauges, RXSpin,
  StrUtils, MaxMin, FMXUtils;

type
  TForm1 = class(TForm)
    FormStorage1: TFormStorage;
    FileName: TFilenameEdit;
    Label1: TLabel;
    Memo1: TRichEdit;
    OffsetEdit: TRxSpinEdit;
    SizeEdit: TRxSpinEdit;
    SaveDialog1: TSaveDialog;
    SaveBtn: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    OffsetLabel: TLabel;
    SizeLabel: TLabel;
    ExitBtn: TButton;
    FileSizeEdit: TEdit;
    FileSizeLabel: TLabel;
    Label5: TLabel;
    StatusBar1: TStatusBar;
    SearchEdit: TEdit;
    Label6: TLabel;
    SearchBtn: TButton;
    procedure SaveBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure FileNameChange(Sender: TObject);
    procedure OffsetEditChange(Sender: TObject);
    procedure SizeEditChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure SearchBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ReadSlice;
  end;
procedure BufferToString(Bytes: Longint);

type PBufferArray = ^TBufferArray;
     TBufferArray = array[1..10000000] of byte;
var
  Form1: TForm1;
  FileOpened: Boolean=False;
  F,F1: Integer;
  FSize: Longint=0;
  Offset: Longint=0;
  SliceSize: Longint=1000;
  S: String;
  B,BPrev: Byte;
  Buffer: Pointer;
  BufferArray: PBufferArray;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  try
    GetMem(BufferArray,10000000);
  except
    ShowMessage('    !');
    Close;
  end;
  FormStorage1.RestoreFormPlacement;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  try FreeMem(BufferArray,10000000); except end;
  if FileOpened then try FileClose(F) except end;
end;

procedure TForm1.SaveBtnClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
    try
      F1:=FileCreate(SaveDialog1.FileName);
      if F1<>-1 then begin
        FileSeek(F,Offset,0);
        FileRead(F,BufferArray^,SliceSize);
        FileWrite(F1,BufferArray^,SliceSize);
        FileClose(F1);
      end;
    except
      FileClose(F1);
    end;
end;

procedure TForm1.ExitBtnClick(Sender: TObject);
begin
  Form1.Close;
end;

procedure TForm1.FileNameChange(Sender: TObject);
begin
  if FileOpened then try FileClose(F) except end;
  FileOpened:=False;
  if FileExists(FileName.FileName) then begin
    try
      F:=FileOpen(FileName.FileName,fmOpenRead or fmShareDenyNone);
      FileSeek(F,0,0);
      FSize:=GetFileSize(FileName.FileName);
      FileSizeEdit.Text:=IntToStr(FSize);
      FileSizeLabel.Caption:='(Hex : '+Dec2Hex(FSize,8)+')';
      if Round(OffsetEdit.Value)>=(FSize-SliceSize) then OffsetEdit.Value:=max(FSize-SliceSize,0);
      OffsetEdit.MaxValue:=max(FSize-1,0);
      FileOpened:=True;
      ReadSlice;
    except
      FileClose(F);
    end;
  end;
end;

procedure BufferToString(Bytes: Longint);
begin
  SetLength(S,Bytes);
  asm
    pushad
    pushfd
    cld
    mov   esi,BufferArray
    mov   edi,S
    mov   ecx,Bytes
    @l1:  lodsb
          or    al,al
          jnz   @m2
    @m1:  mov   al,32
    @m2:  stosb
          loop  @l1
    popfd
    popad
  end;
end;

procedure TForm1.ReadSlice;
begin
  if FileOpened then begin
    Screen.Cursor:=crHourGlass;
    FileSeek(F,Offset,0);
    FileRead(F,BufferArray^,SliceSize);
    BufferToString(SliceSize);
    Memo1.Text:=S;
    Screen.Cursor:=crDefault;
  end;
end;

procedure TForm1.OffsetEditChange(Sender: TObject);
var MaxSize: Longint;
begin
  if OffsetEdit.Value>(FSize-SliceSize) then OffsetEdit.Value:=max(FSize-SliceSize,0);
  Offset:=Round(OffsetEdit.Value);
  MaxSize:=min(FSize-Offset,10000000);
  if Round(SizeEdit.Value)>=MaxSize then SizeEdit.Value:=MaxSize;
  SizeEdit.MaxValue:=MaxSize;
  OffsetLabel.Caption:='(Hex : '+Dec2Hex(Offset,8)+')';
  ReadSlice;
end;

procedure TForm1.SizeEditChange(Sender: TObject);
begin
  SliceSize:=Round(SizeEdit.Value);
  SizeLabel.Caption:='(Hex : '+Dec2Hex(SliceSize,8)+')';
  ReadSlice;
end;

procedure TForm1.SearchBtnClick(Sender: TObject);
var I,Pos: Integer; Founded: Boolean; Off,BuffOff: Longint;
begin
  if SearchEdit.Text='' then begin ShowMessage('    !'); exit; end;
  if FileOpened then begin
    FileSeek(F,Offset,0);
    Founded:=False;
    I:=1; Off:=Offset;
    Screen.Cursor:=crHourGlass;
    while I>0 do begin
      I:=FileRead(F,BufferArray^,SizeOf(BufferArray^));
      BufferToString(SizeOf(BufferArray^));
      BuffOff:=NPos(SearchEdit.Text,S,1);
      Founded:=(BuffOff<>0);
      if Founded then break;
      Inc(Off,I);
    end;
    Screen.Cursor:=crDefault;
    if Founded then begin
      Offset:=Off+BuffOff-1;
      if (FSize-Offset)<SliceSize then SliceSize:=(FSize-Offset);
      OffsetEdit.Value:=Offset;
    end else ShowMessage('   !');
  end;
end;

end.
